StandardSessionFacade (Apache Tomcat 11.0.22 API Documentation)
Description: declaration: package: org.apache.catalina.session, class: StandardSessionFacade

# Class StandardSessionFacade

java.lang.Object
org.apache.catalina.session.StandardSessionFacade

All Implemented Interfaces:
  `HttpSession`

public class StandardSessionFacade extends Object implements HttpSession
Facade for the StandardSession object.

- ## Nested Class Summary

  ### Nested classes/interfaces inherited from interface HttpSession

  `HttpSession.Accessor`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `StandardSessionFacade(HttpSession session)`
  Construct a new session facade.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `HttpSession.Accessor`
  `getAccessor()`
  Provides a mechanism for applications to interact with the `HttpSession` outside of the scope of an HTTP request.
  `Object`
  `getAttribute(String name)`
  Returns the object bound with the specified name in this session, or `null` if no object is bound under the name.
  `Enumeration<String>`
  `getAttributeNames()`
  Returns an `Enumeration` of `String` objects containing the names of all the objects bound to this session.
  `long`
  `getCreationTime()`
  Returns the time when this session was created, measured in milliseconds since midnight January 1, 1970 GMT.
  `String`
  `getId()`
  Returns a string containing the unique identifier assigned to this session.
  `long`
  `getLastAccessedTime()`
  Returns the last time the client sent a request associated with this session, as the number of milliseconds since midnight January 1, 1970 GMT, and marked by the time the container received the request.
  `int`
  `getMaxInactiveInterval()`
  Returns the maximum time interval, in seconds, that the servlet container will keep this session open between client accesses.
  `ServletContext`
  `getServletContext()`
  Returns the ServletContext to which this session belongs.
  `void`
  `invalidate()`
  Invalidates this session then unbinds any objects bound to it.
  `boolean`
  `isNew()`
  Returns `true` if the client does not yet know about the session or if the client chooses not to join the session.
  `void`
  `removeAttribute(String name)`
  Removes the object bound with the specified name from this session.
  `void`
  `setAttribute(String name, Object value)`
  Binds an object to this session, using the name specified.
  `void`
  `setMaxInactiveInterval(int interval)`
  Specifies the time, in seconds, between client requests before the servlet container will invalidate this session.

  ### Methods inherited from class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### StandardSessionFacade

    public StandardSessionFacade(HttpSession session)
    Construct a new session facade.
    Parameters:
      `session` - The session instance to wrap

- ## Method Details

  - ### getCreationTime

    public long getCreationTime()
    Description copied from interface: `jakarta.servlet.http.HttpSession`
    Returns the time when this session was created, measured in milliseconds since midnight January 1, 1970 GMT.
    Specified by:
      `getCreationTime` in interface `HttpSession`
    Returns:
      a `long` specifying when this session was created, expressed in milliseconds since 1/1/1970 GMT

  - ### getId

    public String getId()
    Description copied from interface: `jakarta.servlet.http.HttpSession`
    Returns a string containing the unique identifier assigned to this session. The identifier is assigned by the servlet container and is implementation dependent.
    Specified by:
      `getId` in interface `HttpSession`
    Returns:
      a string specifying the identifier assigned to this session

  - ### getLastAccessedTime

    public long getLastAccessedTime()
    Description copied from interface: `jakarta.servlet.http.HttpSession`
    Returns the last time the client sent a request associated with this session, as the number of milliseconds since midnight January 1, 1970 GMT, and marked by the time the container received the request.

    Actions that your application takes, such as getting or setting a value associated with the session, do not affect the access time.

    Specified by:
      `getLastAccessedTime` in interface `HttpSession`
    Returns:
      a `long` representing the last time the client sent a request associated with this session, expressed in milliseconds since 1/1/1970 GMT

  - ### getServletContext

    public ServletContext getServletContext()
    Description copied from interface: `jakarta.servlet.http.HttpSession`
    Returns the ServletContext to which this session belongs.
    Specified by:
      `getServletContext` in interface `HttpSession`
    Returns:
      The ServletContext object for the web application

  - ### setMaxInactiveInterval

    public void setMaxInactiveInterval(int interval)
    Description copied from interface: `jakarta.servlet.http.HttpSession`
    Specifies the time, in seconds, between client requests before the servlet container will invalidate this session. A zero or negative time indicates that the session should never time out.
    Specified by:
      `setMaxInactiveInterval` in interface `HttpSession`
    Parameters:
      `interval` - An integer specifying the number of seconds

  - ### getMaxInactiveInterval

    public int getMaxInactiveInterval()
    Description copied from interface: `jakarta.servlet.http.HttpSession`
    Returns the maximum time interval, in seconds, that the servlet container will keep this session open between client accesses. After this interval, the servlet container will invalidate the session. The maximum time interval can be set with the `setMaxInactiveInterval` method. A zero or negative time indicates that the session should never time out.
    Specified by:
      `getMaxInactiveInterval` in interface `HttpSession`
    Returns:
      an integer specifying the number of seconds this session remains open between client requests
    See Also:
      - `HttpSession.setMaxInactiveInterval(int)`

  - ### getAttribute

    public Object getAttribute(String name)
    Description copied from interface: `jakarta.servlet.http.HttpSession`
    Returns the object bound with the specified name in this session, or `null` if no object is bound under the name.
    Specified by:
      `getAttribute` in interface `HttpSession`
    Parameters:
      `name` - a string specifying the name of the object
    Returns:
      the object with the specified name

  - ### getAttributeNames

    public Enumeration<String> getAttributeNames()
    Description copied from interface: `jakarta.servlet.http.HttpSession`
    Returns an `Enumeration` of `String` objects containing the names of all the objects bound to this session.
    Specified by:
      `getAttributeNames` in interface `HttpSession`
    Returns:
      an `Enumeration` of `String` objects specifying the names of all the objects bound to this session

  - ### setAttribute

    public void setAttribute(String name, Object value)
    Description copied from interface: `jakarta.servlet.http.HttpSession`
    Binds an object to this session, using the name specified. If an object of the same name is already bound to the session, the object is replaced.

    After this method executes, and if the new object implements `HttpSessionBindingListener`, the container calls `HttpSessionBindingListener.valueBound`. The container then notifies any `HttpSessionAttributeListener`s in the web application.

    If an object was already bound to this session of this name that implements `HttpSessionBindingListener`, its `HttpSessionBindingListener.valueUnbound` method is called.

    If the value passed in is null, this has the same effect as calling `removeAttribute()`.

    Specified by:
      `setAttribute` in interface `HttpSession`
    Parameters:
      `name` - the name to which the object is bound; cannot be null
      `value` - the object to be bound

  - ### removeAttribute

    public void removeAttribute(String name)
    Description copied from interface: `jakarta.servlet.http.HttpSession`
    Removes the object bound with the specified name from this session. If the session does not have an object bound with the specified name, this method does nothing.

    After this method executes, and if the object implements `HttpSessionBindingListener`, the container calls `HttpSessionBindingListener.valueUnbound`. The container then notifies any `HttpSessionAttributeListener`s in the web application.

    Specified by:
      `removeAttribute` in interface `HttpSession`
    Parameters:
      `name` - the name of the object to remove from this session

  - ### invalidate

    public void invalidate()
    Description copied from interface: `jakarta.servlet.http.HttpSession`
    Invalidates this session then unbinds any objects bound to it.
    Specified by:
      `invalidate` in interface `HttpSession`

  - ### isNew

    public boolean isNew()
    Description copied from interface: `jakarta.servlet.http.HttpSession`
    Returns `true` if the client does not yet know about the session or if the client chooses not to join the session. For example, if the server used only cookie-based sessions, and the client had disabled the use of cookies, then a session would be new on each request.
    Specified by:
      `isNew` in interface `HttpSession`
    Returns:
      `true` if the server has created a session, but the client has not yet joined

  - ### getAccessor

    public HttpSession.Accessor getAccessor()
    Description copied from interface: `jakarta.servlet.http.HttpSession`
    Provides a mechanism for applications to interact with the `HttpSession` outside of the scope of an HTTP request.
    Specified by:
      `getAccessor` in interface `HttpSession`
    Returns:
      An `HttpSession.Accessor` instance linked to the current session ID (if the session ID is changed the `HttpSession.Accessor` will no longer be able to access this session)